use DWH_TEST
go

/*

Test-Schritt 1

*/

insert into Staging.Product (ProductID, [Date], Name, Material, Hall, Shelf)
values
	('PCMS002X', '1988-01-01', 'Rollzeiger', 'Panzerstahl', 'Garage', 'Regal li.')

execute Staging.spMergeDimProduct

declare @DWHRowId bigint =
	(
		select min(DWH_ProductID) from DWH.DimProduct
		where ProductID='PCMS002X'
	)
	
insert into DWH.FactOrder ([Date], DWH_ProductID, UnitCount, UnitCost, UnitPrice)
values
	('1988-06-06', @DWHRowId, 10, 300.0, 400.0),
	('1990-03-01', @DWHRowId, 17, 100.0, 200.0),
	('1997-04-02', @DWHRowId, 56, 20.0, 40.0),
	('2016-03-01', @DWHRowId, 120, 10.0, 20.0)

select * from Staging.Product
select * from DWH.DimProduct
select * from DWH.FactOrder
go

/*

Test-Schritt 2

*/

truncate table Staging.Product

insert into Staging.Product (ProductID, [Date], Name, Material, Hall, Shelf)
values
	('PCMS002X', '1997-04-01', 'Maus', 'Holz', 'Keller', 'Regal re.')

execute Staging.spMergeDimProduct

select * from Staging.Product
select * from DWH.DimProduct
select * from DWH.FactOrder
go

/*

Test-Schritt 3

*/

truncate table Staging.Product

insert into Staging.Product (ProductID, [Date], Name, Material, Hall, Shelf)
values
	('PCMS002X', '1997-04-01', 'Maus', 'Holz', 'Dachboden', 'Gr. Kiste'),
	('PCMS002X', '2015-01-01', 'Mouse', 'Kunststoff', 'Halle 1', 'Hochregal')

execute Staging.spMergeDimProduct

select * from Staging.Product
select * from DWH.DimProduct order by InDate
select * from DWH.FactOrder
go
